// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from xrrobot_msgs:msg/Imu.idl
// generated code does not contain a copyright notice
#include "xrrobot_msgs/msg/detail/imu__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `linear_acceleration`
// Member `angular_velocity`
// Member `magnetic_field`
#include "geometry_msgs/msg/detail/vector3__functions.h"

bool
xrrobot_msgs__msg__Imu__init(xrrobot_msgs__msg__Imu * msg)
{
  if (!msg) {
    return false;
  }
  // linear_acceleration
  if (!geometry_msgs__msg__Vector3__init(&msg->linear_acceleration)) {
    xrrobot_msgs__msg__Imu__fini(msg);
    return false;
  }
  // angular_velocity
  if (!geometry_msgs__msg__Vector3__init(&msg->angular_velocity)) {
    xrrobot_msgs__msg__Imu__fini(msg);
    return false;
  }
  // magnetic_field
  if (!geometry_msgs__msg__Vector3__init(&msg->magnetic_field)) {
    xrrobot_msgs__msg__Imu__fini(msg);
    return false;
  }
  return true;
}

void
xrrobot_msgs__msg__Imu__fini(xrrobot_msgs__msg__Imu * msg)
{
  if (!msg) {
    return;
  }
  // linear_acceleration
  geometry_msgs__msg__Vector3__fini(&msg->linear_acceleration);
  // angular_velocity
  geometry_msgs__msg__Vector3__fini(&msg->angular_velocity);
  // magnetic_field
  geometry_msgs__msg__Vector3__fini(&msg->magnetic_field);
}

xrrobot_msgs__msg__Imu *
xrrobot_msgs__msg__Imu__create()
{
  xrrobot_msgs__msg__Imu * msg = (xrrobot_msgs__msg__Imu *)malloc(sizeof(xrrobot_msgs__msg__Imu));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(xrrobot_msgs__msg__Imu));
  bool success = xrrobot_msgs__msg__Imu__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
xrrobot_msgs__msg__Imu__destroy(xrrobot_msgs__msg__Imu * msg)
{
  if (msg) {
    xrrobot_msgs__msg__Imu__fini(msg);
  }
  free(msg);
}


bool
xrrobot_msgs__msg__Imu__Sequence__init(xrrobot_msgs__msg__Imu__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  xrrobot_msgs__msg__Imu * data = NULL;
  if (size) {
    data = (xrrobot_msgs__msg__Imu *)calloc(size, sizeof(xrrobot_msgs__msg__Imu));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = xrrobot_msgs__msg__Imu__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        xrrobot_msgs__msg__Imu__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
xrrobot_msgs__msg__Imu__Sequence__fini(xrrobot_msgs__msg__Imu__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      xrrobot_msgs__msg__Imu__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

xrrobot_msgs__msg__Imu__Sequence *
xrrobot_msgs__msg__Imu__Sequence__create(size_t size)
{
  xrrobot_msgs__msg__Imu__Sequence * array = (xrrobot_msgs__msg__Imu__Sequence *)malloc(sizeof(xrrobot_msgs__msg__Imu__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = xrrobot_msgs__msg__Imu__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
xrrobot_msgs__msg__Imu__Sequence__destroy(xrrobot_msgs__msg__Imu__Sequence * array)
{
  if (array) {
    xrrobot_msgs__msg__Imu__Sequence__fini(array);
  }
  free(array);
}
